---
title: WEBGL_compressed_texture_etc
slug: Web/API/WEBGL_compressed_texture_etc
tags:
  - API
  - Reference
  - WebGL
  - WebGL extension
---
<div>{{APIRef("WebGL")}}</div>

<p>The <code><strong>WEBGL_compressed_texture_etc</strong></code> extension is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> and exposes 10 <a href="https://en.wikipedia.org/wiki/Ericsson_Texture_Compression">ETC/EAC compressed texture formats</a>.</p>

<p>Compressed textures reduce the amount of memory needed to store a texture on the GPU, allowing for higher resolution textures or more of the same resolution textures.</p>

<p>WebGL extensions are available using the {{domxref("WebGLRenderingContext.getExtension()")}} method. For more information, see also <a href="/en-US/docs/Web/API/WebGL_API/Using_Extensions">Using Extensions</a> in the <a href="/en-US/docs/Web/API/WebGL_API/Tutorial">WebGL tutorial</a>.</p>

<div class="note">
<p><strong>Availability:</strong> This extension is available to both, {{domxref("WebGLRenderingContext", "WebGL1", "", 1)}} and {{domxref("WebGL2RenderingContext", "WebGL2", "", 1)}} contexts.</p>
</div>

<h2 id="Constants">Constants</h2>

<p>The compressed texture formats are exposed by 10 constants and can be used in two functions: {{domxref("WebGLRenderingContext.compressedTexImage2D", "compressedTexImage2D()")}} and {{domxref("WebGLRenderingContext.compressedTexSubImage2D", "compressedTexSubImage2D()")}}.</p>

<dl>
 <dt><code>ext.COMPRESSED_R11_EAC</code></dt>
 <dd>One-channel (red) unsigned format compression.</dd>
 <dt><code>ext.COMPRESSED_SIGNED_R11_EAC</code></dt>
 <dd>One-channel (red) signed format compression.</dd>
 <dt><code>ext.COMPRESSED_RG11_EAC</code></dt>
 <dd>Two-channel (red and green) unsigned format compression.</dd>
 <dt><code>ext.COMPRESSED_SIGNED_RG11_EAC</code></dt>
 <dd>Two-channel (red and green) signed format compression.</dd>
 <dt><code>ext.COMPRESSED_RGB8_ETC2</code></dt>
 <dd>Compresses RGB8 data with no alpha channel.</dd>
 <dt><code>ext.COMPRESSED_RGBA8_ETC2_EAC</code></dt>
 <dd>Compresses RGBA8 data. The RGB part is encoded the same as <code>RGB_ETC2</code>, but the alpha part is encoded separately.</dd>
 <dt><code>ext.COMPRESSED_SRGB8_ETC2</code></dt>
 <dd>Compresses sRGB8 data with no alpha channel.</dd>
 <dt><code>ext.COMPRESSED_SRGB8_ALPHA8_ETC2_EAC</code></dt>
 <dd>Compresses sRGBA8 data. The sRGB part is encoded the same as <code>SRGB_ETC2</code>, but the alpha part is encoded separately.</dd>
 <dt><code>ext.COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2</code></dt>
 <dd>Similar to <code>RGB8_ETC</code>, but with ability to punch through the alpha channel, which means to make it completely opaque or transparent.</dd>
 <dt><code>ext.COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2</code></dt>
 <dd>Similar to <code>SRGB8_ETC</code>, but with ability to punch through the alpha channel, which means to make it completely opaque or transparent.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush:js">var ext = gl.getExtension('WEBGL_compressed_texture_etc');

var texture = gl.createTexture();
gl.bindTexture(gl.TEXTURE_2D, texture);

gl.compressedTexImage2D(gl.TEXTURE_2D, 0, ext.COMPRESSED_RGBA8_ETC2_EAC, 512, 512, 0, textureData);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WEBGL_compressed_texture_etc', "", "WEBGL_compressed_texture_etc")}}</td>
   <td>{{Spec2('WEBGL_compressed_texture_etc')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WEBGL_compressed_texture_etc")}}</p>

<h2 id="Compatibility_notes">Compatibility notes</h2>

<ul>
 <li>This extension was named <code>WEBGL_compressed_texture_es3</code> from Firefox 46 to Firefox 51 and used to be available on the WebGL 2 context by default – this is not the case anymore. You have to enable it on both, WebGL 1 and WebGL 2 contexts, in order to use it.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://en.wikipedia.org/wiki/Ericsson_Texture_Compression">Ericsson Texture Compression – Wikipedia</a></li>
 <li>{{domxref("WEBGL_compressed_texture_etc1")}} (ETC1)</li>
 <li>{{domxref("WebGLRenderingContext.getExtension()")}}</li>
 <li>{{domxref("WebGLRenderingContext.compressedTexImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.compressedTexSubImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.getParameter()")}}</li>
</ul>
